------------------------------------------------------------------------
TMB 1.9.25 (2026-08-22)
------------------------------------------------------------------------

o add PROTECT/UNPROTECT to protect against false-positive rchk warning #418.

o Finalize Eigen 5 compatibility.

o Some internal TMB namespaces have been cleaned up.

------------------------------------------------------------------------
TMB 1.9.22 (2026-07-21)
------------------------------------------------------------------------

o Fix clang-14 -std=c++20 RTMB build.

o Add partial Eigen 5.0.0 compatibility.

o Add Conway-Maxwell-Binomial distribution (thanks to Julius Bogomolovas).

o runSymbolicAnalysis() now supports an 'incomplete' Cholesky factorization.

------------------------------------------------------------------------
TMB 1.9.21 (2026-03-22)
------------------------------------------------------------------------

o Package restructure:
  - Github version == CRAN version [no more patching for CRAN]
  - 'Eigen' + 'unsupported' removed [we now completely rely on RcppEigen]
  - All examples wrapped in 'dontrun' [we no longer ship the 'simple' build]

------------------------------------------------------------------------
TMB 1.9.20 (2026-03-17)
------------------------------------------------------------------------

o Avoid non-API 'Rf_findVar'.

------------------------------------------------------------------------
TMB 1.9.19 (2025-12-15)
------------------------------------------------------------------------

o This release adds changes related to the 'TMBad' autodiff component:

- Sparse plus low-rank Hessian now has an 'LDL' option to handle cases
  where the sparse contribution is not positive definite.
- Tape optimizer can now recognize identical checkpoint operators as
  well as identical references to outer contexts.
- Adaptive dynamically retaping checkpoint operators can now safely
  share their derivative table.
- A bug in the 'expm1' operator has been fixed.

------------------------------------------------------------------------
TMB 1.9.18 (2025-10-13)
------------------------------------------------------------------------

o This release adds changes related to the 'TMBad' autodiff component:

  - Very slow `sdreport()` has been fixed.
  - Flag `TMB::config(tmbad.atomic_sparse_log_determinant=TRUE)` is no
    longer ignored by `GMRF_t`.
  - `pow()` operator is now optimized to handle constant operand special
    cases.
  - The experimental Hessian compression algorithm has been improved
    and can now fix many more cases of memory explosion caused by the
    sparse Hessian tape.
    (Enabled using `TMB::config(tmbad.sparse_hessian_compress=TRUE)`)

------------------------------------------------------------------------
TMB 1.9.17 (2025-03-08)
------------------------------------------------------------------------

o splinefun fixes:
  Now handles parameter dependent x values and knots correctly.

o New atomic functions: findInterval, subset, order, sort, fmod.

o Replace non-API 'ENCLOS' by 'R_ParentEnv' (GH #405).

o Fix CRAN ASAN issues reported for the 'tmbstan' package.

o NA integer handling has been postponed as it broke parallelization.

------------------------------------------------------------------------
TMB 1.9.16 (2025-01-08)
------------------------------------------------------------------------

o Improved behavior for sdreport() when using 'bias.correct=TRUE'
  without any random effects (GH #403).

o dnbinom() impoved accuracy (GH #402).

o Handle integer NAs correctly for DATA_I* macros (GH #400).

------------------------------------------------------------------------
TMB 1.9.15 (2024-09-09)
------------------------------------------------------------------------

o Add missing std::numeric_limits for 'TMBad' #398 (fixing undefined
  behaviour in some cases)

o Enable bitwise reproducible results for 'TMBad' by default

------------------------------------------------------------------------
TMB 1.9.14 (2024-07-03)
------------------------------------------------------------------------

o Fix C++20 compiler warning

------------------------------------------------------------------------
TMB 1.9.13 (2024-06-28)
------------------------------------------------------------------------

o Fix isNullPointer #395

------------------------------------------------------------------------
TMB 1.9.12 (2024-06-19)
------------------------------------------------------------------------

o Fix clang-19 build issue

o use Matrix API for SEXP->(cholmod_factor *) coercion (#393)

o Add TMB.Version() #387

o Fix protection bug in REPORT(SparseMatrix)

------------------------------------------------------------------------
TMB 1.9.11 (2024-04-02)
------------------------------------------------------------------------

o Fix conflict between TMB and Eigen parallelization (GH #390).

o Matrix ABI check no longer writes external file during installation
  (GH #392).

o Improved diagnostic messages when data of invalid storage mode is
  passed to TMB (GH #391).

------------------------------------------------------------------------
TMB 1.9.10 (2023-12-12)
------------------------------------------------------------------------

o precompile(): Translation unit changes that should not be visible to
  the user.

------------------------------------------------------------------------
TMB 1.9.9 (2023-11-27)
------------------------------------------------------------------------

o Fix 'Wformat' warnings

------------------------------------------------------------------------
TMB 1.9.7 (2023-11-22)
------------------------------------------------------------------------

o Fixed tweedie integer overflow for extreme parameters.

o Added new argument 'adaptive' to 'tmbprofile'.

o Added new atomic matrix functions 'sqrtm' and 'absm'.

o Avoid unnecessary warnings on 'Matrix package version inconsistency'.

------------------------------------------------------------------------
TMB 1.9.6 (2023-08-11)
------------------------------------------------------------------------

o Fix UBSAN observed for nested AD contexts.

------------------------------------------------------------------------
TMB 1.9.5 (2023-07-18)
------------------------------------------------------------------------

o R: Prepare determinant() change from Matrix version 1.6-0.

o R: oneStepPredict() now allows mixed discrete/continuous distributions.

o C++: New atomic 'fft'.

------------------------------------------------------------------------
TMB 1.9.4 (2023-04-18)
------------------------------------------------------------------------

o Fix internal bug causing wrong 'sparse_matrix_exponential' derivatives.

o Prepare for upcoming Matrix_1.5-5 (Fix misuse of Matrix C-API).

------------------------------------------------------------------------
TMB 1.9.3 (2023-03-28)
------------------------------------------------------------------------

o Prepare for Matrix 1.5-4 deprecations.

o checkConsistency(): New argument 'estimate' enables full simulation
  study and another argument 'observation.name' can be used to not
  retape between simulation replicates.

o oneStepPredict(): Eliminate nuisance warnings from generic method.

o C++ side: Added preprocessor flag 'TMB_ABORT' to better control
  behaviour in 'TMB_SAFEBOUNDS' mode (e.g. signal normal R error
  rather than abort). In addition, 'TMB_CATCH' can now be configured
  to catch more than just std::bad_alloc.

------------------------------------------------------------------------
TMB 1.9.2 (2023-01-23)
------------------------------------------------------------------------

o Improved interoperability with Rcpp (conflicts resolved).

o Fix some broken sparse matrix coercions that used to work.

o New features on C++ side:
  - Atomic sparse matrix exponential.
  - Atomic vectorized operations mainly for internal use.
  - Faster matrix multiply for higher order AD (see example 'hmm_filter').
  - Utility for parameter object concatenation.

o Fix warnings from CRAN check page.

------------------------------------------------------------------------
TMB 1.9.1 (2022-08-16)
------------------------------------------------------------------------

o Prepare for Matrix 1.4-2 deprecations.

o Fix html version of sdreport docs (thanks to Kurt Hornik).

o Constant input test was missing for some special functions.

o Added argument 'max.order' to compile().

o oneStepPredict() CDF method was stabilized.

o 2D interpolation operator was added on C++ side.

------------------------------------------------------------------------
TMB 1.9.0 (2022-05-26)
------------------------------------------------------------------------

o Fix PROTECT bugs (thanks to Tomas Kalibera)

o Behavior if TMB parallization has been changed:
  - Setting the number of threads of a TMB model using TMB::openmp() is now portable across platforms.
  - Number of TMB threads no longer interferes with number of threads used by other packages or BLAS/LAPACK.
  - By default, unless explicitly requested, models run with a single thread.

o precompile() can now auto generate 'TMB.h' and 'TMB.cpp' that may be used by R packages to split in several compilation units.

o MakeADFun() now checks that the DLL is loaded.

------------------------------------------------------------------------
TMB 1.8.1 (2022-03-23)
------------------------------------------------------------------------

o Fix some clang-14 compiler warnings.

------------------------------------------------------------------------
TMB 1.8.0 (2022-03-07)
------------------------------------------------------------------------

o Experimental support for new AD library 'TMBad' - see ?compile.

o Option to discard nuisance warnings from Eigen - see ?compile.

------------------------------------------------------------------------
TMB 1.7.22 (2021-09-28)
------------------------------------------------------------------------

o Fortran character strings: use 'FCONE' macro

o Add .onUnload() (GH #353)

o Fix tmbutils::array ASAN issue triggered by at least clang-13

------------------------------------------------------------------------
TMB 1.7.21 (2021-09-06)
------------------------------------------------------------------------

o Fix CRAN build issue triggered by clang 13.0.0 (omp.h)

o Fix tweedie thread safety on Windows (https://github.com/glmmTMB/glmmTMB/issues/714)

o Fix as.list(.) for class 'sdreport' (https://github.com/glmmTMB/glmmTMB/issues/692)

------------------------------------------------------------------------
TMB 1.7.20 (2021-04-08)
------------------------------------------------------------------------

o Make parList() work in more edge cases.

o Make tiny_ad variables work (again) with Eigen types.

o Avoid header issues in Matrix 1.3-0 due to SuiteSparse update (#340)

------------------------------------------------------------------------
TMB 1.7.19 (2021-02-05)
------------------------------------------------------------------------

o 'sdreport()' failed in a special case (GH #333)

o Improved implementation of 'rtweedie()'

o Fixed thread safety issues (GH #330)

o Fixed 'tmbroot()' and 'tmbprofile()' for single-parameter models

o Function 'compile()' now quotes more paths (GH #323)

------------------------------------------------------------------------
TMB 1.7.18 (2020-07-24)
------------------------------------------------------------------------

o Fix clang-ASAN issue caused by memory management changes

------------------------------------------------------------------------
TMB 1.7.17 (2020-07-23)
------------------------------------------------------------------------

o New function 'FreeADFun()' gives the user more control with memory
  deallocation. In addition memory management of external pointers
  have been improved - see '?FreeADFun'.

o Documentation errors in '?sdreport' have been corrected.

o The function 'oneStepPredict()' now calculates residuals in reverse
  order because it is more stable. Old behaviour can be obtained by
  passing 'reverse=FALSE'.

------------------------------------------------------------------------
TMB 1.7.16 (2020-01-15)
------------------------------------------------------------------------

o Fixed memory leaks in sparse hessian.

o logspace_add: Added some edge case reductions.

o 'oneStepPredict' no longer overwrites mapping of random effects.

o Fix isfinite, isinf, isnan etc (github #297).

o Add support for other object names to 'gdbsource'.

o dbinom: Handle edge cases 0*log(0).

o Add segment method to vector_indicator.

o data_indicator: Add default CTOR.

o splinefun: fix memleak + add vector evaluation.

o Saved models from old TMB versions should now be usable in new TMB
  versions without giving the INTEGER(...) error.

o checkConsistency bugfix: did not work for mapped random effects.

------------------------------------------------------------------------
TMB 1.7.15 (2018-11-08)
------------------------------------------------------------------------

o Allow report array of any type (similar to vector case)

o Solve 'rck' issue from CRAN

o Fix bug in separable simulate

------------------------------------------------------------------------
TMB 1.7.14 (2018-06-23)
------------------------------------------------------------------------

o Fix performance bug triggered by R-devel.

o Fixed bug in sparsity detection algorithm.

o Tweedie atomic function speedup.

o Fix save/reload model object. Loaded object no longer overwrites
  fitted parameters when running e.g. obj$report() or obj$simulate().

o New function 'tmbroot' computes likelihood profile confidence intervals.

------------------------------------------------------------------------
TMB 1.7.13 (2018-03-22)
------------------------------------------------------------------------

o Redundant warnings from CHOLMOD have been silenced.

o ADREPORT now tracks object dimensions. More infomation in
  '?TMB::as.list.sdreport'.

o New feature to do process normalization from R. See
  '?TMB::normalize'.

o New feature to update data from R without re-taping the
  computational graph. Enabled on C++ side using 'DATA_UPDATE'.

o bugfix C++ namespace 'autodiff': Jacobian had wrong dimension.

------------------------------------------------------------------------
TMB 1.7.12 (2017-12-10)
------------------------------------------------------------------------

o Fix CRAN rchk tool warnings (although false alarm)

o New macro TMB_OBJECTIVE_PTR for more flexible use of DATA and
  PARAMETER objects.

o Fix 'oneStepPredict' when no random effects.

o C callable routines 'tmb_forward' and 'tmb_reverse' added.

o Fix bug in empty array assignment.

o Fix slow 'oneStepPredict' caused by matrix inversion in
  'tmbprofile'.

o TMB:::setupRstudio()

o compile: Add flag for tracing forward sweeps.

------------------------------------------------------------------------
TMB 1.7.11 (2017-08-09)
------------------------------------------------------------------------

o Allow logical data objects

o Fix conversion R <-> C++ of long objects
  - Can now pass long vector (length >= 2^31) as DATA_VECTOR.
  - Can now REPORT a long vector.
  - Can now calculate long jacobian matrices (m*n can be greater than
    2^31 where n is the number of parameters and m the number of
    ADREPORTed variables).

o Fixed a possible segmentation fault in sparsity detection algorithm.

o New flag to sdreport() reduces memory usage when bias correcting a
  large number of variables.

o New experimental function checkConsistency() to check the Laplace
  approximation and correctness of the user template.

------------------------------------------------------------------------
TMB 1.7.10 (2017-05-03)
------------------------------------------------------------------------

o Fix broken Solaris build caused by Eigen 3.3.3 update

------------------------------------------------------------------------
TMB 1.7.9 (2017-04-12)
------------------------------------------------------------------------

o Fix PROTECT bugs reported by Tomas Kalibera.

o Now possible to use 'autodiff::hessian' in conjunction with atomic
  functions.

o Fix 'testthat:::expect_equal(obj, obj)' crash for non-random effect
  models.

o Fix compatibility issues of 'tmbutils::vector' with eigen 3.3.2.

------------------------------------------------------------------------
TMB 1.7.8 (2017-02-08)
------------------------------------------------------------------------

o Internal bug fixes.
  - Fix bug in GMRF constructor from grid array.
  - Fix printing of Eigen/AD types (broken by version 1.7.7)

------------------------------------------------------------------------
TMB 1.7.7 (2017-01-31)
------------------------------------------------------------------------

o Internal modifications:
  - Fix Eigen 3.3.2 compatibility issues.
  - Disable dynamic symbols.

------------------------------------------------------------------------
TMB 1.7.6 (2017-01-15)
------------------------------------------------------------------------

o Add Conway-Maxwell-Poisson distribution (dcompois, rcompois).

o Add lfactorial.

o Move MCMC to separate package.

o Add simulators for exponential, beta, F, logistic, Student T, and
  Weibull distributions.

o Fix a bug in function 'split'.

------------------------------------------------------------------------
TMB 1.7.5 (2016-11-20)
------------------------------------------------------------------------

o Atomic logspace_add and logspace_sub.

o Numerically robust binomial and negative binomial density functions.

o New macros:
  - DATA_STRING to pass strings from R.
  - SIMULATE to mark blocks of simulation code.

o Simulation methods implemented for density classes:
  - MVNORM, AR1, SCALE, VECSCALE, SEPARABLE, GMRF, ARk.

o R-style simulators now available from the template:
  - rnorm, runif, rpois, rbinom, rgamma, rnbinom and rnbinom2.

------------------------------------------------------------------------
TMB 1.7.4 (2016-09-21)
------------------------------------------------------------------------

o Add onLoad check on 'Matrix' package version.

o runExample: Fixed bug when running all examples from a specified
  example folder.

o sdreport: Fixed bug in the case with exactly one random effect.

o sdreport: Reduced size of output.

------------------------------------------------------------------------
TMB 1.7.3 (2016-09-05)
------------------------------------------------------------------------

o New atomic functions:
  - pbeta
  - qbeta
  - dtweedie
  - besselK (derivatives wrt both arguments)
  - besselI (derivatives wrt both arguments)
  - besselJ (derivatives wrt both arguments)
  - besselY (derivatives wrt both arguments)

o Adaptive numerical integration:
  - gauss_kronrod::integrate     (one dimension)
  - gauss_kronrod::mvIntegrate   (multiple dimensions)

o sdreport: Fix bug that caused bias.correction to break when
  parameter maps were in use.

------------------------------------------------------------------------
TMB 1.7.2 (2016-08-09)
------------------------------------------------------------------------

o sdreport: Allow bias correct in chunks to reduce memory.

o Experimental TMB:::install.contrib to install user contributed cpp
  code from github.

o Disable CHOLMOD warnings from inner problem when silent=TRUE.

o sdreport: Keep running when solve(hessian) fails.

o sdreport: Fix bug that caused summary(sdreport(.)) to fail when
  nothing was ADREPORTed.

------------------------------------------------------------------------
TMB 1.7.1 (2016-05-05)
------------------------------------------------------------------------

o Lots of minor performance optimizations.

o sdreport: New argument getReportCovariance.
  - Reduces memory usage when many variables are ADREPORTed.

o bugfix: numeric(0) in random list of MakeADFun caused wrong
  parameter list.

o New atomic: convol2d

------------------------------------------------------------------------
TMB 1.7.0 (2016-03-22)
------------------------------------------------------------------------

o CITATION update with JSS publication.

o New function 'as.list.sdreport' converts from sdreport format to
  original parameter list structure.

o MCMC:
  - Fix small bug in transforming intial values in NUTS.
  - Rename mcmc -> run_mcmc to avoid conflict with coda package.

------------------------------------------------------------------------
TMB 1.6.6 (2016-01-28)
------------------------------------------------------------------------

o oneStepPredict: Add one-step mean to output for methods
  'oneStepGaussianOffMode' and 'oneStepGeneric'.

o Array class changes:
  - More explicit array assignment from other class:
  Can now assign from matrix and un-evaluated expression template
  E.g. a = a.matrix() * a.matrix();
  - Documentation: warning about the 2D case
  - Re-implement vec() operator (avoid loop)
  - Add method matrix() to array class: Keeps first dimension and
    collapses remaining dimensions.

o Clean up potential naming conflicts caused by Rmath macros

o Atomic functions general speedup

o bugfix: precompile broke REGISTER_ATOMIC

------------------------------------------------------------------------
TMB 1.6.5 (2015-12-02)
------------------------------------------------------------------------

o Fix bug that caused sdreport to fail for models using the 'profile'
  argument to MakeADFun.

o Robustify marginal likelihood for extreme parameters (to help MCMC).

o MCMC: Improved stability of adaptive step size algorithm.

o Bias correction documentation and test example. Results are now part
  of the summary output.

------------------------------------------------------------------------
TMB 1.6.4 (2015-11-22)
------------------------------------------------------------------------

o precompile() makeover:
  - Works on all platforms.
  - Works with multiple models in same R instance.
  - Frequently used classes MVNORM_t and GMRF_t added to precompilation.

------------------------------------------------------------------------
TMB 1.6.3 (2015-11-11)
------------------------------------------------------------------------

o Fix array rows() method (The method inherited from Eigen would
  report the length of the underlying vector).

o Eliminate std::cout in CRAN version.

o MCMC samplers (HMC, NUTS and RWM) added by Cole Monnahan.

------------------------------------------------------------------------
TMB 1.6.0 (2015-10-08)
------------------------------------------------------------------------

o Major changeset to get closer to CRAN submission

  - Added 'dontrun' to most examples. Reason: All useful TMB examples
  take too long time to run because they require compilation.

  - Removed TMB-internals.

  - Added Roxygen for remaining functions: dynlib()
  runSymbolicAnalysis() config() plot.parallelBenchmark()
  summary.sdreport() print.sdreport() print.backtrace()
  plot.tmbprofile() confint.tmbprofile()

  - Got rid of global configuration, e.g flagsDefaults(),
  newtonDefaults() etc.

  - Reworked newtonOption() and adapted all examples to new syntax.
  (NOTE: not entirely backwards compatible since to old version
  modified global settings, which we do not allow anymore).

  - Fixed several typos, e.g. c++ -> C++

  - CITATION: Added arxiv reference.

  - DESCRIPTION: Changed title and added URL.

  - NAMESPACE: Cleanup

o CppAD jacobian: prefer reverse mode over forward mode if work is equal
  - TMB only requires 1st order reverse (not forward) mode to be
  implemented for atomic functions. This can result in the error
  'order not implemented' if CppAD automatically selects forward over
  reverse mode.
  - In cases where the work of forward and reverse mode are equal it
  is therefore more natural (from TMB perspective) to select reverse
  mode.

o Document parallel_accumulator #122

o Lots of doxygen documentation updates

------------------------------------------------------------------------
TMB 1.5-1 (2015-10-04)
------------------------------------------------------------------------

o From now on the github version follows the R version

o Added NEWS file

o Emacs mode version 3.0 from Arni Magnusson

o Robustify tmbprofile() #137

o Experimental oneStepPredict() now handles discrete case as part of a
  general 'oneStepGeneric' method.

o tmbprofile() multiple changes
  - Allow specification of a valid range of the parameter.
  - Get more detail in the center of the distribution.
    (does not affect cases where likelihood has been optimized)

o C++: New namespace 'autodiff' makes it easy to use AD from the user
  template.

o C++: New namespace 'romberg' with wrappers around CppAD integration
  routines.

o Automatic retape when loading saved ADFun objects.

o Keep attribute 'check.passed' when subsetting parameter list

o Fix 32 bit

o match pattern: Improvement for large problems. As a result it is now
  be possible to handle 2^31-1 nonzeros in Cholesky factor. Old method
  would break down around 2^30.

o MVNORM_t: Method to evaluate marginals.

o oneStepPredict() now works with maps #108.

o Lots of improvements and cleanups from Martin Maechler.

------------------------------------------------------------------------
TMB 1.5-0 (2015-08-10)
------------------------------------------------------------------------

o Add pnorm/qnorm one-argument vectorized versions.

o bugfix: Vectorized math operations crashed in the zero-length case.

o Add missing bounds check to array class #100 - Now checks each index
  component (not just the re-mapped univariate index).

o BesselK atomic + Matern correlation function.

o asSparseMatrix and asSparseVector fix: Conversion from dense to sparse
  should not drop zero-entries that could potentially become nonzero
  (i.e. parameter dependent entries).

o CppAD::Variable now works for TMB models.

o Script to enable 'runSymbolicAnalysis' on all Linux and OS X systems.

o New experimental function 'oneStepPredict' for OSA residuals with
  ar1xar1 as an example.

o New atomic function 'ppois'.

o REPORT: Allow report vector of 'anything'.

o getUserDLL: Improve guess of user's DLL code (when DLL not given to
  MakeADFun).

o Eliminate warning with '-Wpedantic'.

o sdreport new option: ignore.parm.uncertainty.

o New example: HMM filter.

o General 1D likelihood profile function + method to get profile
  confidence intervals + plot method.

o MakeADFun: New option to move outer parameters to the inner problem
  (purpose: get same speed as the REML trick for linear fixed effects
  without loosing the ML interpretation).

o MakeADFun: New argument 'silent' to disable all tracing output.

------------------------------------------------------------------------
TMB 1.4-0 (2015-04-16)
------------------------------------------------------------------------

o CppAD updated to development version. Reduced peak memory usage with
  up to 50% for large models.

o New configuration variables.

o Avoid crashes due to memory allocation errors.

o Print index errors to error stream.

o Allow compilation with -std=c++11.

o sdreport: bias.correct optimizations.

o Implement up to 7d array (like admb).

o Allow lists as data object with R-inla SPDE structures as an example.

------------------------------------------------------------------------
TMB 1.0-0 (2013-09-10)
------------------------------------------------------------------------

o Initial release.
